package org.rcisoft.business.opmArticle.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import org.rcisoft.business.cmsBanner.entity.CmsBanner;
import org.rcisoft.business.opmArticle.entity.ArticleCommentDTO;
import org.rcisoft.business.opmArticle.entity.LikeDTO;
import org.rcisoft.business.opmArticle.entity.OpmArticle;
import org.rcisoft.core.model.CyPageInfo;
import org.rcisoft.core.model.CyPersistModel;

import java.util.List;

/**
 * Created by cy on 2024年3月30日 下午1:51:15.
 */
public interface OpmArticleService {

    /**
    * 保存 opmArticle管理
    * @param opmArticle
    * @return
    */
    CyPersistModel persist(OpmArticle opmArticle);

    /**
    * 删除 opmArticle管理
    * @param opmArticle
    * @return
    */
    CyPersistModel remove(OpmArticle opmArticle);

    /**
    * 逻辑删除 opmArticle管理
    * @param opmArticle
    * @return
    */
    CyPersistModel removeLogical(OpmArticle opmArticle);

    /**
    * 修改 opmArticle管理
    * @param opmArticle
    * @return
    */
    CyPersistModel merge(OpmArticle opmArticle);

    /**
    * 根据id查询 opmArticle管理
    * @param id
    * @return
    */
    OpmArticle findById(Integer id);

    /**
    * 分页查询 opmArticle管理
    * @param opmArticle
    * @return
    */
    IPage<OpmArticle> findAllByPagination(CyPageInfo<OpmArticle> paginationUtility,
                                          OpmArticle opmArticle,String type);


    /**
    * 查询list opmArticle管理
    * @param opmArticle
    * @return
    */
    List<OpmArticle> findAll(OpmArticle opmArticle);


    /**
    * 导出opmArticle管理
    * @return
    */
    List<OpmArticle> export(OpmArticle opmArticle);

    /**
     * 逻辑删除 评论
     * @param opmArticle
     * @return
     */
    CyPersistModel removeComment(OpmArticle opmArticle);

    /**
     * 点赞增加点赞数
     * @param articleId
     * @return
     */
    CyPersistModel likeAdd(Integer articleId,String praiseType);

    /**
     * 评论增加点赞数
     * @param commentId
     * @return
     */
    CyPersistModel likeCommentAdd(Integer commentId,String praiseType);

    /**
     * 添加评论
     * @param dto
     * @return
     */
    CyPersistModel addComment(ArticleCommentDTO dto);

    /**
     * 分页查询某个人的动态列表
     * @param opmArticle
     * @return
     */
    IPage<OpmArticle>  findUserArticleByPagination(CyPageInfo<OpmArticle> paginationUtility, OpmArticle opmArticle);
}
